// TraceSender.h: interface for the CTraceSender class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TRACESENDER_H__78B1026C_6B52_4F6D_B8EB_2ABEBB6228F6__INCLUDED_)
#define AFX_TRACESENDER_H__78B1026C_6B52_4F6D_B8EB_2ABEBB6228F6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TraceTypes.h"

#ifdef TRACESENDER_DLL
#define TRACESENDER_EXP __declspec(dllexport)
#else
#define TRACESENDER_EXP __declspec(dllimport)
#endif

#ifdef USE_TRACER
// macros to be used instead directly call of CTraceSender::Send
// they include the current file name and line number in the text displayes in Tracer.
#define DEBUG_TRACE0(txt) CTraceSender::Send(TraceType::eDebug,__FILE__,__LINE__,txt)
#define ERROR_TRACE0(txt) CTraceSender::Send(TraceType::eError,__FILE__,__LINE__,txt)
#define SQL_TRACE0(txt) CTraceSender::Send(TraceType::eSQL,__FILE__,__LINE__,txt)
#define COMMENT_TRACE0(txt) CTraceSender::Send(TraceType::eComment,__FILE__,__LINE__,txt)

#define DEBUG_TRACE1(format, p1) CTraceSender::SendV(TraceType::eDebug,__FILE__,__LINE__,format,p1)
#define ERROR_TRACE1(format, p1) CTraceSender::SendV(TraceType::eError,__FILE__,__LINE__,format,p1)
#define SQL_TRACE1(format, p1) CTraceSender::SendV(TraceType::eSQL,__FILE__,__LINE__,format,p1)
#define COMMENT_TRACE1(format, p1) CTraceSender::SendV(TraceType::eComment,__FILE__,__LINE__,format,p1)

#define DEBUG_TRACE2(format, p1, p2) CTraceSender::SendV(TraceType::eDebug,__FILE__,__LINE__,format,p1,p2)
#define ERROR_TRACE2(format, p1, p2) CTraceSender::SendV(TraceType::eError,__FILE__,__LINE__,format,p1,p2)
#define SQL_TRACE2(format, p1, p2) CTraceSender::SendV(TraceType::eSQL,__FILE__,__LINE__,format,p1,p2)
#define COMMENT_TRACE2(format, p1, p2) CTraceSender::SendV(TraceType::eComment,__FILE__,__LINE__,format,p1,p2)

#define DEBUG_TRACE3(format, p1, p2, p3) CTraceSender::SendV(TraceType::eDebug,__FILE__,__LINE__,format,p1,p2,p3)
#define ERROR_TRACE3(format, p1, p2, p3) CTraceSender::SendV(TraceType::eError,__FILE__,__LINE__,format,p1,p2,p3)
#define SQL_TRACE3(format, p1, p2, p3) CTraceSender::SendV(TraceType::eSQL,__FILE__,__LINE__,format,p1,p2,p3)
#define COMMENT_TRACE3(format, p1, p2, p3) CTraceSender::SendV(TraceType::eComment,__FILE__,__LINE__,format,p1,p2,p3)
   
#else
// if USE_TRACER is not defined, these macros will be ignored in the preprocessor phase
   #define DEBUG_TRACE0(txt)
   #define ERROR_TRACE0(txt)
   #define SQL_TRACE0(txt)
   #define COMMENT_TRACE0(txt)

   #define DEBUG_TRACE1(format,p1)
   #define ERROR_TRACE1(format,p1)
   #define SQL_TRACE1(format,p1)
   #define COMMENT_TRACE1(format,p1)

   #define DEBUG_TRACE2(format,p1,p2)
   #define ERROR_TRACE2(format,p1,p2)
   #define SQL_TRACE2(format,p1,p2)
   #define COMMENT_TRACE2(format,p1,p2)

   #define DEBUG_TRACE3(format,p1,p2,p3)
   #define ERROR_TRACE3(format,p1,p2,p3)
   #define SQL_TRACE3(format,p1,p2,p3)
   #define COMMENT_TRACE3(format,p1,p2,p3)
#endif // USE_TRACER

#define DEBUG_TRACE     DEBUG_TRACE0
#define ERROR_TRACE     ERROR_TRACE0
#define SQL_TRACE       SQL_TRACE0
#define COMMENT_TRACE   COMMENT_TRACE0

class TRACESENDER_EXP CTraceSender  
{
private:
   CTraceSender() {}
   virtual ~CTraceSender();
// Attributes
protected:
   static COPYDATASTRUCT m_cds;
// Operations
public:
   static void Send(TraceType::e_TraceType eType, LPCTSTR pszFile, int nLine, LPCTSTR pszText);
   static void SendV(TraceType::e_TraceType eType, LPCTSTR pszFile, int nLine, LPCTSTR pszFormat, ...);
// Implementation
protected:
   static void GetFormattedTimestamp(const SYSTEMTIME& timeStamp, CString& strTimestamp);
};

#endif // !defined(AFX_TRACESENDER_H__78B1026C_6B52_4F6D_B8EB_2ABEBB6228F6__INCLUDED_)
